﻿Class MainWindow 
    Dim start_flag As Boolean
    Dim th As System.Threading.Thread
    Dim comm As String
    Private Sub MainWindow_Closing(sender As Object, e As ComponentModel.CancelEventArgs) Handles Me.Closing
        th.Abort()
    End Sub
    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        'Dim aa As Human
        'For i = 1 To 5
        '    aa = New Human(i, 1, 0)
        '    aa.Width = 100 + (i - 1) * 20
        '    aa.HorizontalAlignment = Windows.HorizontalAlignment.Center
        '    aa.VerticalAlignment = Windows.VerticalAlignment.Center
        '    Canvas.SetTop(aa, i * 100 - aa.Width / 2)
        '    Canvas.SetLeft(aa, i * 100)
        '    cv.Children.Add(aa)
        'Next
        start_flag = False
        Dim sth As New System.Threading.ThreadStart(AddressOf rsd)

        th = New System.Threading.Thread(sth)
        th.SetApartmentState(System.Threading.ApartmentState.STA)
        cbSerial.Items.Clear()
        For Each aa As String In IO.Ports.SerialPort.GetPortNames
            cbSerial.Items.Add(aa)
        Next
        If cbSerial.Items.Count > 0 Then cbSerial.SelectedIndex = 0
        TB_ST.Text = "シリアルポートを選択してください。"
        ' AddHandler RS.DataReceived, AddressOf RS_Recv
    End Sub
    Delegate Sub cv_clear_del()
    Sub cv_clear()
        cv.Children.Clear()
    End Sub
    Delegate Sub cv_add_del(x As Integer, y As Integer, size As Integer, 年齢 As Integer, 性別 As Integer, 表情 As Integer)
    Sub cv_add(x As Integer, y As Integer, size As Integer, 年齢 As Integer, 性別 As Integer, 表情 As Integer)
        Dim human As Human
        human = New Human(表情, 年齢, 性別)
        human.Width = size
        human.HorizontalAlignment = Windows.HorizontalAlignment.Center
        human.VerticalAlignment = Windows.VerticalAlignment.Center
        Canvas.SetTop(human, y - size / 2)
        Canvas.SetLeft(human, (640 - (x - size / 2)))
        cv.Children.Add(human)
    End Sub

    Sub rsd()
        Dim RS As IO.Ports.SerialPort
        RS = New IO.Ports.SerialPort(comm, 9600, IO.Ports.Parity.None, 8, IO.Ports.StopBits.One)
        RS.Open()
        Dim aa As String
        Do
            If RS.BytesToRead > 2 Then
                Try
                    aa = RS.ReadLine
                Catch ex As Exception
                    aa = ""
                End Try
                aa = aa.Replace(vbLf, "").Replace(vbCr, "")
                Console.WriteLine(aa)

                If aa.StartsWith("#") = False Then
                    '#で始まるのはコメント
                    If aa = "DATA_START" Then
                        '                        cv.Children.Clear()
                        _face = New List(Of StFACE)
                        _old = New List(Of StOld)
                        _sex = New List(Of StSex)
                        _exp = New List(Of StExp)
                        start_flag = True
                    ElseIf start_flag Then
                        If aa = "DATA_END" Then
                            Dim No_exp_1 As Integer = 0
                            Dim No_exp_2 As Integer = 0
                            Dim No_exp_3 As Integer = 0
                            Dim No_exp_4 As Integer = 0
                            Dim No_exp_5 As Integer = 0
                            Dim no As Integer = 999
                             If no > _face.Count Then no = _face.Count
                            If no > _old.Count Then no = _old.Count
                            If no > _sex.Count Then no = _sex.Count
                            If no > _exp.Count Then no = _exp.Count
                            Dispatcher.Invoke(New cv_clear_del(AddressOf cv_clear))
                            For i = 0 To no - 1
                                If _exp(i).exp = 1 Then No_exp_1 += 1
                                If _exp(i).exp = 2 Then No_exp_2 += 1
                                If _exp(i).exp = 3 Then No_exp_3 += 1
                                If _exp(i).exp = 4 Then No_exp_4 += 1
                                If _exp(i).exp = 5 Then No_exp_5 += 1

                                'cv.Children.Add(human)
                                Dispatcher.Invoke(New cv_add_del(AddressOf cv_add), _face(i).x, _face(i).y, _face(i).size, _old(i).old, _sex(i).Sex, _exp(i).exp)
                            Next
                            Dispatcher.Invoke(New tb_count_del(AddressOf tb_count), No_exp_1, No_exp_2, No_exp_3, No_exp_4, No_exp_5)
                        Else
                            Dim ab() As String = aa.Split(":")
                            If ab(0) = "Face" Then
                                Dim __face As New StFACE
                                __face.No = ab(1)
                                __face.x = ab(2)
                                __face.y = ab(3)
                                __face.size = ab(4)
                                _face.Add(__face)
                            ElseIf ab(0) = "FaceOld" Then
                                Dim __old As New StOld
                                __old.no = ab(1)
                                __old.old = ab(2)
                                _old.Add(__old)
                            ElseIf ab(0) = "FaceSex" Then
                                Dim __sex As New StSex
                                __sex.no = ab(1)
                                __sex.Sex = ab(2)
                                _sex.Add(__sex)
                            ElseIf ab(0) = "FaceExpression" Then
                                Dim __exp As StExp
                                __exp.no = ab(1)
                                __exp.exp = ab(2)
                                _exp.Add(__exp)
                            End If

                        End If

                    End If
                End If
            Else
                System.Threading.Thread.Sleep(500)
            End If
        Loop
    End Sub
    Structure StFACE
        Dim No As Integer
        Dim x As Integer
        Dim y As Integer
        Dim size As Integer
    End Structure
    Dim _face As List(Of StFACE)
    Structure StOld
        Dim no As Integer
        Dim old As Integer
    End Structure
    Dim _old As List(Of StOld)
    Structure StSex
        Dim no As Integer
        Dim Sex As Integer
    End Structure
    Dim _sex As List(Of StSex)
    Structure StExp
        Dim no As Integer
        Dim exp As Integer
    End Structure
    Dim _exp As List(Of StExp)
    Delegate Sub tb_count_del(no_exp_1 As Integer, no_exp_2 As Integer, no_exp_3 As Integer, no_exp_4 As Integer, no_exp_5 As Integer)

    Sub tb_count(no_exp_1 As Integer, no_exp_2 As Integer, no_exp_3 As Integer, no_exp_4 As Integer, no_exp_5 As Integer)
        TB_Exp_1.Text = "無表情： " & no_exp_1 & "人"
        TB_Exp_2.Text = "喜び： " & no_exp_2 & "人"
        TB_Exp_3.Text = "驚き： " & no_exp_3 & "人"
        TB_Exp_4.Text = "怒り： " & no_exp_4 & "人"
        TB_Exp_5.Text = "悲しみ： " & no_exp_5 & "人"
    End Sub
    'Sub rs_recv(sender As Object, e As IO.Ports.SerialDataReceivedEventArgs)
    '    Dim aa As String = RS.ReadLine
    '    Console.WriteLine(aa)

    '    If aa.StartsWith("#") = False Then
    '        '#で始まるのはコメント
    '        If aa = "DATA_START" Then
    '            ' cv.Children.Clear()
    '            _face = New List(Of StFACE)
    '            _old = New List(Of StOld)
    '            _sex = New List(Of StSex)
    '            _exp = New List(Of StExp)
    '            start_flag = True
    '        ElseIf start_flag Then
    '            If aa = "DATA_END" Then
    '                Dim No_exp_1 As Integer = 0
    '                Dim No_exp_2 As Integer = 0
    '                Dim No_exp_3 As Integer = 0
    '                Dim No_exp_4 As Integer = 0
    '                Dim No_exp_5 As Integer = 0
    '                Dim no As Integer = 999
    '                Dim human As Human
    '                If no > _face.Count Then no = _face.Count
    '                If no > _old.Count Then no = _old.Count
    '                If no > _sex.Count Then no = _sex.Count
    '                If no > _exp.Count Then no = _exp.Count
    '                For i = 0 To no - 1
    '                    If _exp(i).exp = 1 Then No_exp_1 += 1
    '                    If _exp(i).exp = 2 Then No_exp_2 += 1
    '                    If _exp(i).exp = 3 Then No_exp_3 += 1
    '                    If _exp(i).exp = 4 Then No_exp_4 += 1
    '                    If _exp(i).exp = 5 Then No_exp_5 += 1
    '                    human = New Human(i, _old(i).old, _sex(i).Sex)
    '                    human.Width = _face(i).size
    '                    human.HorizontalAlignment = Windows.HorizontalAlignment.Center
    '                    human.VerticalAlignment = Windows.VerticalAlignment.Center
    '                    Canvas.SetTop(human, _face(i).y - _face(i).size / 2)
    '                    Canvas.SetLeft(human, _face(i).x - _face(i).size / 2)
    '                    '       cv.Children.Add(human)
    '                Next
    '                Dispatcher.Invoke(New tb_count_del(AddressOf tb_count), No_exp_1, No_exp_2, No_exp_3, No_exp_4, No_exp_5)
    '            Else
    '                Dim ab() As String = aa.Split(":")
    '                If ab(0) = "Face" Then
    '                    Dim __face As New StFACE
    '                    __face.No = ab(1)
    '                    __face.x = ab(2)
    '                    __face.y = ab(3)
    '                    __face.size = ab(4)
    '                    _face.Add(__face)
    '                ElseIf ab(0) = "FaceOld" Then
    '                    Dim __old As New StOld
    '                    __old.no = ab(1)
    '                    __old.old = ab(2)
    '                    _old.Add(__old)
    '                ElseIf ab(0) = "FaceSex" Then
    '                    Dim __sex As New StSex
    '                    __sex.no = ab(1)
    '                    __sex.Sex = ab(2)
    '                    _sex.Add(__sex)
    '                ElseIf ab(0) = "FaceExpression" Then
    '                    Dim __exp As StExp
    '                    __exp.no = ab(1)
    '                    __exp.exp = ab(2)
    '                    _exp.Add(__exp)
    '                End If

    '            End If

    '        End If
    '    End If
    'End Sub

    Protected Overrides Sub Finalize()

        MyBase.Finalize()
    End Sub

    Private Sub btn_Click(sender As Object, e As RoutedEventArgs) Handles btn.Click
        btn.IsEnabled = False
        cbSerial.IsEnabled = False
        comm = cbSerial.SelectedItem
        TB_ST.Text = "これは、顔の表情を読み取るセンサーです。画像の取得・保存はありません。"
        th.Start()
    End Sub
End Class
